<script setup lang="ts">
import { useBillPaymentStore } from '@/stores/billPayment';
import { useTypeStore } from '@/stores/type';
import type { BillPayment } from '@/types/BillPayment';
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const billPaymentStore = useBillPaymentStore()
const typeStore = useTypeStore()
const headers = [
  {
    title: 'ID',
    key: 'id'
  },
  {
    title: 'Type',
    key: 'type',
    sortable: false,
    value: 'type' //name
  },
  {
    title: 'Total (Baht)',
    key: 'total',
    value: 'total'
  },
  {
    title: 'Date',
    key: 'date',
    value: 'date'
  },
  {
    title: 'Time',
    key: 'time',
    value: 'time'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

// const search = ref('')
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
// const editedBillPayment = ref<BillPayment>(JSON.parse(JSON.stringify(initialBillPayment)))
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    billPaymentStore.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await billPaymentStore.deleteBillPayment()
  closeDelete()
}
async function editItem(item: BillPayment) {
  if (!item.id) return
  await billPaymentStore.getBillPayment(item.id)
  dialog.value = true
}
async function deleteItem(item: BillPayment) {
  if (!item.id) return
  await billPaymentStore.getBillPayment(item.id)
  dialogDelete.value = true
}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    billPaymentStore.clearForm()
  })
}
async function save() {
  await billPaymentStore.saveBillPayment()
  closeDialog()

  // const { valid } = await refForm.value!.validate()
  // if (!valid) return
  // await billPaymentStore.saveBillPayment()
  // closeDialog()
}
onMounted(async () => {
  await billPaymentStore.getBillPayments()
  await typeStore.getTypes()
})
</script>

<template>
  <div>
    <v-data-table style="background-color: #efe7e1" 
    :headers="headers" 
    :items="billPaymentStore.billPayments">
      <template v-slot:top>
        <v-toolbar flat style="color: #f5f3ef; background-color: #8b7565">
          <v-toolbar-title>Bill Payment</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog-->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                style="color: #0043c7; background-color: #f9f8f5"
                class="custom-button"
                v-bind="props"
                prepend-icon="mdi-plus"
              >
                Bill Payment
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Bill Payment</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          v-model="billPaymentStore.editedBillPayment.typeBill"
                          :items="typeStore.types"
                          item-title="name"
                          item-value="id"
                          label="Type"
                          :return-object="true"
                        ></v-combobox>
                        
                        <!-- //Old version// -->
                        <!-- <v-text-field
                          v-model="editedBillPayment.type"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Type"
                        ></v-text-field -->
                        
                      ></v-col>
                      <v-col cols="12" sm="6"
                        ><v-text-field
                          v-model="billPaymentStore.editedBillPayment.total"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Total"
                        ></v-text-field
                      ></v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Are you sure you want to delete this?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="#81322c" class="me-2" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" color="#81322c" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="billPaymentStore.getBillPayments"> Reset </v-btn>
      </template></v-data-table
    >
  </div>
</template>

<style>
.custom-button {
  margin: 5px; /* เว้นระยะห่าง */
  border-radius: 20px; /* make the roundness */
  padding: 10px 20px;
}
</style>
